import Vue from 'vue';
import Router from 'vue-router';

Vue.use(Router);
const originalPush = Router.prototype.push;
Router.prototype.push = function push(location) {
    return originalPush.call(this, location).catch(err => err)
};

import formRenderRouter from '../router';
let arrPages = [...formRenderRouter.pages];
let arrMenus = [...formRenderRouter.menus];

/*
** 导出vue-router
*/
const router = new Router({
    // 普通build的时候需要不需要设置mode（保持默认#，不然项目不部署跑不起来,需要结合vue.config.js里的baseUrl:'./'）,其他模式需要设置
    mode: (process.env.VUE_APP_MODE == 'jsp' || process.env.NODE_ENV == 'development') ? 'history' : '',
    routes: [
        {path: "/", name:"index", component: () => import("./views/index.vue")},
        {path: "/index", name:"index", component: () => import("./views/index.vue")},
        ...arrMenus,
        // {path: "/newEntrance", name:"newEntrance", component: () => import("./views/components/newEntrance")},
        ...arrPages,
    ]
});

// 导航守卫
// 使用 router.beforeEach 注册一个全局前置守卫，判断用户是否登陆
router.beforeEach((to, from, next) => {
    //如果去往登录页则放行
    if (to.path === '/') {
        next();
    }else if(to.path.indexOf("/formResourceView/") > -1){
        next();
    }else{
        // 从本地存储里获取token
        let suffix = window.projectSuffix || "";
        let token = localStorage.getItem('USERTOKEN' + suffix);
        // 判断token是否为空如果为空则跳转到登录页 如果有则放行
        if (token === null || token === '') {
            next({path:'/'});
        } else {
            next();
        }
    }
});

export default router;
